--- BuildMaster.py.orig	2008-09-08 00:54:17.323939544 +0200
+++ BuildMaster.py	2008-09-08 01:00:53.657940344 +0200
@@ -388,9 +388,17 @@
     def is_paused(self):
         return self._paused
 
+    def _ping_db(self):
+        try:
+            self._cursor.execute('SELECT uid FROM jobs LIMIT 1')
+        except StandardError, e:
+            print "DB Error: could not access jobs database. Reason: '%s'" % e
+
     def run(self):
         DebugUtils.registerThreadName(self)
 
+        self._next_db_ping = time.time()+3600
+
         self._dbcx = self._db_manager.dbcx()
         self._cursor = self._dbcx.cursor()
 
@@ -411,6 +419,10 @@
                 self._start_new_jobs()
                 self._start_requeued_jobs()
 
+                if time.time() > self._next_db_ping:
+                    self._next_db_ping = time.time()+3600
+                    self._ping_db()
+
             last_time = time.time()
             while not self._have_work() and time.time() <= last_time + 5:
                 time.sleep(0.25)
